/*
** Copyright 2001, Michael Pfeiffer	
*/

#ifndef _TV_OUT_H
#define _TV_OUT_H

#include <SupportDefs.h> /* for status_t */
#include <add-ons/graphics/Accelerant.h> /* for display_mode */

#if defined(__cplusplus)
extern "C" {
#endif

#define TV_OUT_ADDON_API_VERSION 2

/* Global variable must be exported by add-on*/
extern int32 _EXPORT api_version; /* initialize with TV_OUT_ADDON_API_VERSION */

/* 
   After the module is loaded by GDW load_tv_out() is invoked and must 
   return B_OK if it supports the gaphics card it finds otherwise
   it must return B_ERROR.
*/
status_t _EXPORT load_tv_out(int driver_fd);

/*
   unload_tv_out() is called before the module is unloaded, but only
   if load_tv_out returned B_OK.
*/
void     _EXPORT unload_tv_out(void);

typedef status_t (set_display_mode_t)(display_mode *mode_to_set);

/*
   If set_display_mode is called with TV_OUT_MODE or DUAL_MODE as its
   "mode" parameter it must return B_OK to indicate successful switching
   to tv-out mode or B_ERROR otherwise. 
   
   If switching to tv-out mode was successful, it is guaranteed, 
   that mode == VGA_MODE at next invokation of set_display_mode and
   the function must setup vga mode correctly, but does not need to
   (and should not) set the display mode. 
*/
status_t _EXPORT set_tv_out_mode(display_mode *mode_to_set, 
                                  enum tv_out_mode mode,
                                  set_display_mode_t *set_display_mode);


#if defined(__cplusplus)
}
#endif


#endif
